
// Подключаем библиотеки
#include <glcd.h> 
#include "SystemFont5x7R.h" // файл шрифта
#include <Wire.h>
#include <DS1307.h>
#include <Barometer.h>
#include <SHT1x.h>

//инициализируем
DS1307 clock;//define a object of DS1307 class
#define dataPin  16 //A2
#define clockPin 17 //A3
SHT1x sht1x(dataPin, clockPin);
Barometer Bar;
//Переменные
float temperature; //из датчика давления - ее надо читать
float pressure; //давление Па 
int mmHg; //давление мм
  float temp_c; //температура град С
  float humidity; //влажность
int count;//счетчик для дисплея
float volt_batt; //напряжение батареи
char volt[5]; //напряжение батареи ASCII "4.41"
word i_time = 0; //текущее время
word t_time = 0; //время приема
int command = 0; 

void clock_USB_set()
{
int C_year = 0;   // переменные для установки часов
byte C_month = 0;
byte C_date = 0;
byte C_hour = 0;
byte C_minites = 0;
byte C_sec = 0;
byte C_day = 0;
delay (5); //подбирается опытным путем
      C_year = Serial.read()+2000; 
      C_month = Serial.read();// 3 - март
      C_date =  Serial.read(); // 17 - дата
delay (5); //подбирается опытным путем
      C_hour =  Serial.read(); // 10 - часов
      C_minites =  Serial.read(); // 30 - минут
      C_sec =  Serial.read(); // 21 - секунд
delay (1); //подбирается опытным путем
      C_day =  Serial.read(); // 1 - день недели 
   clock.stopClock();
	clock.fillByYMD(C_year,C_month,C_date); //mart 17,2014
	clock.fillByHMS(C_hour,C_minites,C_sec); //10:30:21 
	clock.fillDayOfWeek(C_day);//день недели = 1
	clock.setTime();//write time to the RTC chip
   clock.startClock();
   command = 0;
delay (10);
	Serial.print("Ok");
}//end clock_USB_set

void printTime() //вывод часов во внешнюю программу
{
	clock.getTime();
	Serial.print(clock.hour, DEC);
	Serial.print(":");
	Serial.print(clock.minute, DEC);
	Serial.print(":");
	Serial.print(clock.second, DEC);
	Serial.print("	");
	Serial.print(clock.dayOfMonth, DEC);
	Serial.print(".");
	Serial.print(clock.month, DEC);
	Serial.print(".");
	Serial.print(clock.year+2000, DEC);
	Serial.print(" ");
	switch (clock.dayOfWeek)// см. файл ds1307.h
	{
		case MON:
		  Serial.print("MON");
		  break;
		case TUE:
		  Serial.print("TUE");
		  break;
		case WED:
		  Serial.print("WED");
		  break;
		case THU:
		  Serial.print("THU");
		  break;
		case FRI:
		  Serial.print("FRI");
		  break;
		case SAT:
		  Serial.print("SAT");
		  break;
		case SUN:
		  Serial.print("SUN");
		  break;
	}
	Serial.println(" ");
   command = 0; //на всякий случай
}


void setup()
{
   delay(1000);
   Serial.begin(9600); //здесь это Xbee - для приема сигнала от выносного датчика
   Bar.init();
   clock.begin();
//	clock.fillByYMD(2014,3,17);//mart 17,2014 //установка часов для первого раза во время отладки
//	clock.fillByHMS(19,49,30);//18:05 30"
//	clock.fillDayOfWeek(MON);//Saturday
//	clock.setTime();//write time to the RTC chip

GLCD.Init(); //инициализация дисплея
GLCD.SelectFont(System5x7);  //выбираем шрифт
GLCD.ClearScreen();
}

void loop() 
{
  count++; //увеличиваем count на 1
  if (count%2 == 0) //каждый второй раз - вывод датчиков, каждый первый - часы
  {//датчики
  temperature = Bar.bmp085GetTemperature(Bar.bmp085ReadUT()); //Get the temperature, bmp085ReadUT MUST be called first
  pressure = Bar.bmp085GetPressure(Bar.bmp085ReadUP());//Get the pressure (in Paskal)
  mmHg = int(pressure*0.0075)+5;//перевод из Па в ммHg, 5 - экспериментально определенная поправка датчика
  temp_c = sht1x.readTemperatureC(); //запасная температура
  humidity = sht1x.readHumidity();
//========= внутреняя температура и влажность
  GLCD.CursorToXY(0,0); //установим курсор в начальную позицию 
  GLCD.print("Дома:     ");
  if (temperature >= 0) 
  { 
    GLCD.print("+");
  }
  if (abs(temp_c)<10) Serial.print("0");
  GLCD.print(temperature, 1);
  GLCD.print("\134C ");
  GLCD.print(humidity, 0);
  GLCD.print("%  ");

//=========== внешняя температура и влажность  
  GLCD.CursorToXY(0,2*8); //третья строка 
  GLCD.print("На улице: ");

  i_time = millis(); //текущее время
  if ((i_time - t_time) > 15000) //если t_time не обновлялось более 15 сек
  {
    GLCD.print("- - - - - -"); //то датчик не найден
  } 
if (Serial.available() > 0) 
     {
                // read the incoming byte:
     command = Serial.read();               
     if (command == 79) //буква O - прием с Xbee
     {
  t_time = millis(); //обновляем t_time 
  GLCD.CursorToXY(10*6,2*8); //установим курсор в 11 позицию 3-й строки
      delay (100); 
      byte count_char = 0; //после T count_char=5, после H = 8, напряжение не выводим
  while (Serial.available()>0)
  {
       char data_P = Serial.read();
       count_char++;
       if ((count_char > 9) && (count_char < 14)) {volt[count_char-10] = data_P; //напряжение
       } else
       {
       GLCD.print(data_P);
       if (count_char == 5) GLCD.print("\134C"); //град С
       if (count_char == 8) GLCD.print("%"); //влажность
       }
  }
     } // end command=79
     else if (command == 68) //символ D 
      {
         clock_USB_set(); //устанавливаем часы    
      } else if (command == 82) //символ R
      {     
	printTime(); //выводим часы наружу
      } // end command
     } //end Serial.available
//преобразуем напряжение
volt_batt = atof(volt); //преобразуем в число
//volt[4] = '\0'; для проверки
//GLCD.CursorToXY(0,0);
//GLCD.print(volt_batt,3);
// ========= давление 
GLCD.CursorToXY(0,3*8+3); //чуть ниже строки 4 давление
  GLCD.print("Давление: ");
GLCD.print(mmHg, DEC);
GLCD.print(" мм Hg");
  } else //нечетные значения count
  
  {// ======== вывод часов
  clock.getTime();
  GLCD.CursorToXY(6*6,5*8); //в поз. 7 строки 6 - время
  if (clock.hour<10) 
  GLCD.print("O"); //дополняем нулем
  GLCD.print(clock.hour, DEC);
        GLCD.print(":");
  if (clock.minute<10) GLCD.print("O");
  GLCD.print(clock.minute, DEC);
	GLCD.print(":");
  if (clock.second<10) GLCD.print("O");
  GLCD.print(clock.second, DEC);
  //календарь
  GLCD.CursorToXY(4*6,6*8); //в 5 поз. строки 7 - дата
  if (clock.dayOfMonth<10) GLCD.print("O");
  GLCD.print(clock.dayOfMonth, DEC);
  GLCD.print(" ");
  switch (clock.month)
    {
      case 1:
	GLCD.print("января"); //января
	break;
      case 2:
	GLCD.print("февраля"); //февраля
	break;
      case 3:
	GLCD.print("марта"); //марта
	break;
      case 4:
	GLCD.print("апреля"); //апреля
	break;
      case 5:
	GLCD.print("мая"); //мая
	break;
      case 6:
	GLCD.print("июня"); //июня
	break;
      case 7:
	GLCD.print("июля"); //июля
	break;
      case 8:
	GLCD.print("августа"); //августа
	break;
      case 9:
	GLCD.print("сентября"); //сентября
	break;
      case 10:
	GLCD.print("октября"); //октября
	break;
      case 11:
	GLCD.print("ноября"); //ноября
	break;
      case 12:
	GLCD.print("декабря"); //декабря
	break;
    }
    GLCD.print(" ");
    GLCD.print(clock.year+2000);
    GLCD.print(" ");
  GLCD.CursorToXY(6*6,7*8); //в восьмую строку 5 поз. - день недели
  switch (clock.dayOfWeek)// вывод дней недели по-русски
	{
		case MON:
		  GLCD.print("понедельник"); //понед
		  break;
		case TUE:
		  GLCD.print("вторник"); //вторн
		  break;
		case WED:
		  GLCD.print("cpeда"); //среда
		  break;
		case THU:
		  GLCD.print("четверг"); //четв_
		  break;
		case FRI:
		  GLCD.print("пятница"); //пятн_
		  break;
		case SAT:
		  GLCD.print("суббота"); //субб_
		  break;
		case SUN:
		  GLCD.print("воскресенье"); //воскр
		  break;
	} //end вывод часов
  }
//сигнализируем, что батарейки пора менять  
if (count%4 == 0) //каждый четвертый раз - подмигиваем
{
if (volt_batt < 3.3)  
{
 GLCD.CursorToXY(0,2*8);
 GLCD.print("         "); //пустую строку вместо "На улице"
 delay(100);
//GLCD.print(volt_batt,3);
}
}
} //end loop


